/*******************************************************
 *
 *                    Header files
 *
 *******************************************************/
#include <arpa/inet.h>
#include <fcntl.h>
#include <math.h>
#include <netdb.h>
#include <netinet/in.h>
#include <pthread.h>
#include <signal.h>
#include <stdarg.h>
#include <stdio.h>
#include <stdlib.h>
#include <strings.h>
#include <string.h>
#include <sys/file.h>
#include <sys/stat.h>
#include <sys/socket.h>
#include <sys/types.h>
#include <sys/time.h>
#include <sys/socket.h>
#include <unistd.h>
#include <errno.h>
#include <assert.h>
#include <netinet/tcp.h>


/*******************************************************
 *
 * Definition
 *
 *******************************************************/
#include "debug.h"

/*******************************************************
 *
 * Typedef
 *
 *******************************************************/
typedef enum {
  FALSE,
  TRUE
} BOOLEAN;
typedef enum {
  ANSWER_AGG4TUPLE_NOT_IMPLEMENTED,
  ANSWER_APPEND, 
  ANSWER_ATTR_NOT_EXIST,
  ANSWER_BEGIN, 
  ANSWER_CANNOT_CREATE_WINDOW,
  ANSWER_COMMIT, 
  ANSWER_CREATE_INDEX, 
  ANSWER_CREATE_MONITOR, 
  ANSWER_CREATE_TABLE, 
  ANSWER_CREATE_WINDOW, 
  ANSWER_DELETE, 
  ANSWER_DROP_TABLE, 
  ANSWER_DROP_INDEX, 
  ANSWER_FINISH_MONITOR_RUN, 
	ANSWER_FUNCTION_WRONG,
  ANSWER_INSERT, 
	ANSWER_INSERT_FAILED,
  ANSWER_NOT_BEGIN, 
  ANSWER_PARSE_ERROR, 
  ANSWER_RELATION, 
  ANSWER_ROLLBACK_NO_BUFFERPOOL, 
  ANSWER_ROLLBACK_USER_REQUEST, 
  ANSWER_SHOW_MONITOR,
  ANSWER_SHOW_SCHEMA,
  ANSWER_SHOW_WINDOW,
  ANSWER_TABLE_EXIST,
  ANSWER_TABLE_NOT_EXIST,
  ANSWER_TUPLE_EXIST,
  ANSWER_TUPLE_ID_MUST_BE_ZERO,
  ANSWER_TUPLE_ID_WRONG,
  ANSWER_TUPLE_NOT_EXIST,
  ANSWER_WINDOW_EXIST,
  ANSWER_WRONG_ATTRIBUTE,
  ANSWER_WRONG_ORDER,
  ANSWER_WRONG_SCHEMA,
	ANSWER_WRONG_SENSOR_ID,
  ANSWER_WRONG_WHERE_CLAUSE,
  ANSWER_UNACCEPTABLE
} TYPE_OF_ANSWER;
typedef enum {
  OPERATE_APPEND, 
  OPERATE_COMMIT, 
  OPERATE_CREATE_INDEX, 
  OPERATE_CREATE_MONITOR, 
  OPERATE_CREATE_TABLE, 
  OPERATE_CREATE_WINDOW, 
  OPERATE_DELETE, 
  OPERATE_DROP_TABLE, 
  OPERATE_DROP_INDEX, 
  OPERATE_INSERT, 
  OPERATE_SELECT, 
  OPERATE_SHOW_MONITOR,
  OPERATE_SHOW_SCHEMA,
  OPERATE_SHOW_WINDOW,
  OPERATE_RUN_MONITOR, 
  OPERATE_UNACCEPTABLE
} TYPE_OF_OPERATION;
typedef enum {
  AGG4TUPLE_NOT_IMPLEMENTED,
  ATTR_NOT_EXIST,
  CANNOT_CREATE_WINDOW,
	FUNCTION_WRONG,
	INSERT_FAILED,
  PARSE_OK,
  TABLE_EXIST,
  TABLE_NOT_EXIST,
  TUPLE_EXIST,
  TUPLE_ID_MUST_BE_ZERO,
  TUPLE_ID_WRONG,
  TUPLE_NOT_EXIST,
  WINDOW_EXIST,
  WRONG_ATTRIBUTE,
  WRONG_ORDER,
  WRONG_SCHEMA,
	WRONG_SENSOR_ID,
  WRONG_WHERE_CLAUSE
} PARSE_MSG;

#ifdef USE_ERTF
#include </usr/src/lib/libpthread/thread/kraft_ertf.h>
#ifndef _BUFFSIZE_H
#include "buffsize.h"
#define _BUFFSIZE_H
#endif
typedef struct _QUEUE_LIST {
  long long ary[QUEUE_LIST_SIZE];
  long long flag[QUEUE_LIST_SIZE];
  char cs[QUEUE_LIST_SIZE];
  int policy[QUEUE_LIST_SIZE];
  struct _QUEUE_LIST *next;
  int line;
  char func[BUFFSIZE];
} QUEUE_LIST;
QUEUE_LIST HeadQueueList;
QUEUE_LIST *TailQueueListP;
pthread_mutex_t MutexForQueueList;
#endif
