#define NUM_CNXT 128
typedef enum {MCTL_LOGREC, MCTL_TUPLE} MCTLTYPE;

typedef struct _MCTL {
  unsigned long begin;
  unsigned long end;
  struct _MCTL *next;
  struct _MCTL *prev;
} MCTL;

typedef struct _CNXT {
  void *buffPool; /* Unless heap, we cannot allocate memory */
  pthread_rwlock_t lock; /* Lock for the buffer pool */
  MCTL head;
  MCTL *tailP;
  /* Following variables are for group commit */
  long long sndtm; /* Time of send */
  int gfd1;        /* Group Commit for Host 1 */
  int gfd2;        /* Group Commit for Host 2 */       
} CNXT; /* Memory Context */

typedef struct _MMGR {
  pthread_rwlock_t lock;
  int chkPtrfd;
  CNXT cnxt[NUM_CNXT];  
  unsigned int cid;  /* Current Context id */
} MMGR; /* Context ManaGeR */
